import { login, logout, getInfo } from '@/api/login'
import { listUser } from '@/api/system/user'
import { listDept } from '@/api/system/dept'
import { getToken, setToken, removeToken } from '@/utils/auth'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    deptId: '',
    deptName: '',
    roles: [],
    permissions: [],
    userList: [],
    deptList: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_DEPTID: (state, deptId) => {
      state.deptId = deptId
    },
    SET_DEPTNAME: (state, deptName) => {
      state.deptName = deptName
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    },
    SET_USERLIST: (state, userList) => {
      state.userList = userList
    },
    SET_DEPTLIST: (state, deptList) => {
      state.deptList = deptList
    },
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid).then(res => {
          setToken(res.token)
          commit('SET_TOKEN', res.token)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.user
          let avatar = require("@/assets/images/user.png")
          if (user.avatar == "" || user.avatar == null)
            avatar = user.sex == '0' ? avatar : require("@/assets/images/female.png")
          else
            avatar = process.env.VUE_APP_BASE_API + user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_ID', user.userId)
          commit('SET_NAME', user.nickName)
          commit('SET_DEPTID', user.deptId)
          commit('SET_DEPTNAME', user.dept.deptName)
          commit('SET_AVATAR', avatar)
          listUser({ pageNum: 1, pageSize: 9999 }).then(result => {
            commit('SET_USERLIST', result.rows)
            listDept({ pageNum: 1, pageSize: 9999 }).then(response => {
              let deptList = response.data.filter(item => item.deptName != '四川中水成勘院测绘工程有限责任公司')
              commit('SET_DEPTLIST', deptList)
            })
          })
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
